<template>
  <div>
    <div class="kb_dashboard" style="display:flex;flex-direction: column;justify-content: space-between">

      <div class="kb_backgroundCustom" />

      <div class="kb_header">
        <div class="kb_headTime" style="top: 35px;left:  20px">
          <span>永康市桥下塑料厂</span>
        </div>

        <div class="kb_headTime kb_header_text" style="top: 35px;left:  800px">
          <span>季铭综合数字化看板</span>
        </div>

        <div class="kb_headTime" style="top: 35px;right:  25px">
          <span>{{ headTime }}</span>
        </div>
      </div>
      <div
        style=" padding:5px 20px 20px 20px;z-index:2;height: 940px;flex-direction: column;justify-content: space-between;"
      >
        <!--        上边-->
        <div style="display: flex;justify-content: space-between">
          <div style="width: 925px;">
            <div class="smallTitle">
              <svg-icon icon-class="blcs" class="svg_class" />
              采购订单(月/季)
            </div>
            <div
              class="lineContent horn"
              style="height: 450px;display: flex;flex-direction: column;justify-content: space-between"
            >
              <div style="height: 180px;padding: 10px;display: flex;justify-content: space-between">

                <div v-for="i in LeftTopData01" :key="i.Quarter" class="flex_c_s">
                  <div class="all_block03 flex_c_s">
                    <div class="flex_c_c all_block04">{{ i.Quarter }}</div>
                    <div class="" style="display: flex;justify-content:space-between">
                      <div class="all_block04 flex_c_c" style="width: 49% ">任务数</div>
                      <div class="all_block04 flex_c_c" style="width: 49% ">{{ i.quantity }}</div>
                    </div>
                    <div class="" style="display: flex;justify-content:space-between">
                      <div class="all_block04 flex_c_c" style="width: 49% ">入库数</div>
                      <div class="all_block04 flex_c_c" style="width: 49% ">{{ i.ouquantity }}</div>
                    </div>
                  </div>
                </div>

              </div>
              <div style="height: 260px;">
                <div id="all02_1" class="flex_c_c" style="width: 100%;height:100%;" />
              </div>
            </div>
          </div>
          <div style="width: 925px;">
            <div class="smallTitle">
              <svg-icon icon-class="cggz" class="svg_class" />
              销售订单(月/季)
            </div>
            <div
              class="lineContent horn"
              style="height: 450px;display: flex;flex-direction: column;justify-content: space-between"
            >
              <div style="height: 180px;padding: 10px;display: flex;justify-content: space-between">

                <div v-for="i in RightTopData01" :key="i.Quarter" class="flex_c_s">
                  <div class="all_block03 flex_c_s">
                    <div class="flex_c_c all_block04">{{ i.Quarter }}</div>
                    <div class="" style="display: flex;justify-content:space-between">
                      <div class="all_block04 flex_c_c" style="width: 49% ">任务数</div>
                      <div class="all_block04 flex_c_c" style="width: 49% ">{{ i.quantity }}</div>
                    </div>
                    <div class="" style="display: flex;justify-content:space-between">
                      <div class="all_block04 flex_c_c" style="width: 49% ">出库数</div>
                      <div class="all_block04 flex_c_c" style="width: 49% ">{{ i.ouquantity }}</div>
                    </div>
                  </div>
                </div>

              </div>
              <div style="height: 260px;">
                <div id="all02" class="flex_c_c" style="width: 100%;height:100%;" />
              </div>
            </div>
          </div>
        </div>
        <!--        下边-->
        <div style="display: flex;justify-content: space-between;margin-top: 15px;">
          <div style="width: 925px;">
            <div class="smallTitle">
              <svg-icon icon-class="cxjg" class="svg_class" />
              生产订单(当月)
            </div>
            <div
              class="lineContent horn"
              style="height: 380px;display: flex;flex-direction: column;justify-content: space-between"
            >
              <div style="height: 180px;padding: 10px;display: flex;justify-content: space-evenly">
                <div v-for="i in LeftBottomData01" :key="i.wkshp_code" class="flex_c_s">
                  <div class="all_block01 flex_c_s" style="width: 275px;">
                    <div class="flex_c_c all_block02" style="">{{ i.wkshp_name }}</div>
                    <div class="" style="display: flex;justify-content:space-between">
                      <div class="all_block02 flex_c_c" style="width: 49% ">任务数</div>
                      <div class="all_block02 flex_c_c" style="width: 49% ">{{ i.plan_qty }}</div>
                    </div>
                    <div class="" style="display: flex;justify-content:space-between">
                      <div class="all_block02 flex_c_c" style="width: 49% ">完工数</div>
                      <div class="all_block02 flex_c_c" style="width: 49% ">{{ i.good_qty }}</div>
                    </div>
                  </div>
                </div>

              </div>
              <div style="height: 260px;">
                <div id="all01" class="flex_c_c" style="width: 100%;height:100%;" />
              </div>
            </div>
          </div>
          <div style="width: 925px;">
            <div class="smallTitle">
              <svg-icon icon-class="ckkc" class="svg_class" />
              仓库库存
            </div>
            <div class="lineContent horn" style="height: 380px;display: flex;justify-content: space-between">
              <div style="display: flex;justify-content: center;position: relative">
                <div class="kb_center_block_children all_block05">
                  <div style="font-size: 24px;">{{ parseFloat(RightBottom.Y) }}</div>
                  <div class="box02" />
                  <div>原材料</div>
                </div>
                <div class="kb_center_block_children all_block06">
                  <div style="font-size: 24px;">{{ parseFloat(RightBottom.B) }}</div>
                  <div class="box02" />
                  <div>半成品</div>
                </div>
                <div class="kb_center_block_children all_block07">
                  <div style="font-size: 24px;">{{ parseFloat(RightBottom.C) }}</div>
                  <div class="box02" />
                  <div>产成品</div>
                </div>

              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import './kbCommon.css'
import { loadEcharts, all02, all03 } from '@/utils/myEcharts'
import {
  WorkShopCompreLeftBottom, WorkShopCompreLeftTop, WorkShopCompreRightBottom, WorkShopCompreRightTop
} from '@/api/kanbanManager'

export default {
  name: 'Cjsc',
  data() {
    return {
      headTime: '',
      tableDataRightTop: [],
      wkshopArr: [],
      legendData: [],

      LeftTopData01: [],
      LeftTopData02: [],

      RightTopData01: [],
      RightTopData02: [],

      LeftBottomData01: [],
      LeftBottomData02: [],

      RightBottom: {}

    }
  },
  created() {
    setInterval(this.getNowTime, 1000)

    // // 两小时看板刷新一次
    setInterval(() => {
      window.location.reload()
    }, 1000 * 60 * 120)
  },
  mounted() {
    this.getAllApi()
  },
  methods: {
    async getAllApi() {
      // const { data: res } = await ShopSearch()
      const res = [
        { org_code: '101', org_name: '发泡车间' },
        { org_code: '102', org_name: '挤出车间' }

      ]
      this.wkshopArr = res
      const temp = this.wkshopArr.map(i => i.org_code)
      // const temp = this.wkshopArr.map(i => i.org_code)

      temp.forEach(i => {
        const aa = this.wkshopArr.find(j => j.org_code === i).org_name
        this.legendData.push(aa)
      })

      // 左上 采购订单
      const res2 = await WorkShopCompreLeftBottom()
      res2.data.BottomLeftTop.forEach(i => {
        this.LeftTopData01.push({
          Quarter: i.Quarter,
          quantity: i.quantity,
          ouquantity: i.ouquantity
        })
      })
      res2.data.BottomLeftBottom.forEach(i => {
        this.LeftTopData02.push({
          Month: i.Month + '月',
          quantity: i.quantity,
          ouquantity: i.ouquantity
        })
      })
      loadEcharts('all02_1', all02(this.LeftTopData02, '每月采购数量/入库数量'))
      setInterval(() => {
        this.LeftTopData01 = []
        this.LeftTopData02 = []
        WorkShopCompreLeftBottom().then(res2 => {
          res2.data.BottomLeftTop.forEach(i => {
            this.LeftTopData01.push({
              Quarter: i.Quarter,
              quantity: i.quantity,
              ouquantity: i.ouquantity
            })
          })
          res2.data.BottomLeftBottom.forEach(i => {
            this.LeftTopData02.push({
              Month: i.Month + '月',
              quantity: i.quantity,
              ouquantity: i.ouquantity
            })
          })
          loadEcharts('all02_1', all02(this.LeftTopData02, '每月采购数量/入库数量'))
        })
      }, 1000 * 35)

      // 右上 销售订单
      const res3 = await WorkShopCompreRightTop()
      res3.data.RightTop.forEach(i => {
        this.RightTopData01.push({
          Quarter: i.Quarter,
          quantity: i.quantity,
          ouquantity: i.ouquantity
        })
      })
      res3.data.RightBottom.forEach(i => {
        this.RightTopData02.push({
          Month: i.Month + '月',
          quantity: i.quantity,
          ouquantity: i.ouquantity
        })
      })
      loadEcharts('all02', all02(this.RightTopData02, '每月订单数量/出库数量'))
      setInterval(() => {
        WorkShopCompreRightTop().then(res3 => {
          this.RightTopData01 = []
          this.RightTopData02 = []
          res3.data.RightTop.forEach(i => {
            this.RightTopData01.push({
              Quarter: i.Quarter,
              quantity: i.quantity,
              ouquantity: i.ouquantity
            })
          })
          res3.data.RightBottom.forEach(i => {
            this.RightTopData02.push({
              Month: i.Month + '月',
              quantity: i.quantity,
              ouquantity: i.ouquantity
            })
          })
          loadEcharts('all02', all02(this.RightTopData02, '每月订单数量/出库数量'))
        })
      }, 1000 * 40)

      // 左下 生产订单
      const res4 = await WorkShopCompreLeftTop({ wkshopcode: temp.join(',') })
      for (const res4Key in res4.data.LeftTop) {
        const data = {
          good_qty: 0,
          plan_qty: 0,
          wkshp_code: '',
          wkshp_name: ''
        }
        if (temp.includes(res4Key)) {
          data.good_qty = res4.data.LeftTop[res4Key][0].good_qty
          data.plan_qty = res4.data.LeftTop[res4Key][0].plan_qty
          data.wkshp_code = res4.data.LeftTop[res4Key][0].wkshp_code
          data.wkshp_name = this.wkshopArr.find(i => i.org_code === data.wkshp_code).org_name
          this.LeftBottomData01.push(data)
        }
      }
      for (const res4Key in res4.data.LeftBottom) {
        const data = {
          quantity: 0,
          wkshp_code: '',
          wkshp_name: ''
        }
        if (temp.includes(res4Key)) {
          data.quantity = res4.data.LeftBottom[res4Key][0].quantity
          data.plan_qty = res4.data.LeftBottom[res4Key][0].plan_qty
          data.wkshp_code = res4.data.LeftBottom[res4Key][0].wkshp_code
          data.wkshp_name = this.wkshopArr.find(i => i.org_code === data.wkshp_code).org_name
          this.LeftBottomData02.push(data)
        }
      }
      loadEcharts('all01', all03(this.legendData, this.LeftBottomData02))

      setInterval(() => {
        WorkShopCompreLeftTop({ wkshopcode: temp.join(',') }).then(res2 => {
          this.LeftBottomData01 = []
          this.LeftBottomData02 = []
          for (const res4Key in res4.data.LeftTop) {
            const data = {
              good_qty: 0,
              plan_qty: 0,
              wkshp_code: '',
              wkshp_name: ''
            }
            if (temp.includes(res4Key)) {
              data.good_qty = res2.data.LeftTop[res4Key][0].good_qty
              data.plan_qty = res2.data.LeftTop[res4Key][0].plan_qty
              data.wkshp_code = res2.data.LeftTop[res4Key][0].wkshp_code
              data.wkshp_name = this.wkshopArr.find(i => i.org_code === data.wkshp_code).org_name
              this.LeftBottomData01.push(data)
            }
          }
          for (const res4Key in res2.data.LeftBottom) {
            const data = {
              quantity: 0,
              wkshp_code: '',
              wkshp_name: ''
            }
            if (temp.includes(res4Key)) {
              data.quantity = res2.data.LeftBottom[res4Key][0].quantity
              data.plan_qty = res2.data.LeftBottom[res4Key][0].plan_qty
              data.wkshp_code = res2.data.LeftBottom[res4Key][0].wkshp_code
              data.wkshp_name = this.wkshopArr.find(i => i.org_code === data.wkshp_code).org_name
              this.LeftBottomData02.push(data)
            }
          }
          loadEcharts('all01', all03(this.legendData, this.LeftBottomData02))
        })
      }, 1000 * 30)

      // 右下 仓库库存
      const res5 = await WorkShopCompreRightBottom()
      this.RightBottom = res5.data

      setInterval(() => {
        WorkShopCompreRightBottom().then(res5 => {
          this.RightBottom = res5.data
        })
      }, 1000 * 60)
    },

    // 获取Echarts
    getEcharts() {
      // loadEcharts('cjzl01', cjzl01(this.cjzl01Data))

      // loadEcharts('cjzl02_1', cjzl02(this.cjzl02_1Title, this.cjzl02_1Data))
      // loadEcharts('cjzl02_2', cjzl02(this.cjzl02_2Title, this.cjzl02_2Data))
      // loadEcharts('cjzl02_3', cjzl02(this.cjzl02_3Title, this.cjzl02_3Data))
      // loadEcharts('cjzl02_4', cjzl02(this.cjzl02_4Title, this.cjzl02_4Data))
      // loadEcharts('cjzl02_5', cjzl02(this.cjzl02_5Title, this.cjzl02_5Data))

      // loadEcharts('cjzl04', cjzl04(this.legendData, this.cjzl04Data[0], this.cjzl04Data[1], this.cjzl04Data[2]))// 右侧
      // loadEcharts('cjzl03', cjzl03(this.cjzl03_xData, this.legendData, this.cjzl03_yData))// 左侧
    },

    // 获取当前时间
    getNowTime() {
      const dt = new Date()
      const wk = dt.getDay()
      const y = dt.getFullYear()
      const m = (dt.getMonth() + 1 + '').padStart(2, '0')
      const d = (dt.getDate() + '').padStart(2, '0')

      const hh = (dt.getHours() + '').padStart(2, '0')
      const mm = (dt.getMinutes() + '').padStart(2, '0')
      const ss = (dt.getSeconds() + '').padStart(2, '0')
      const weeks = ['星期日', '星期一', '星期二', '星期三', '星期四', '星期五', '星期六']
      const week = weeks[wk]

      this.headTime = `${y}-${m}-${d}  ${hh}:${mm}:${ss}   ${week}`
    },
    headerCellStyle() {
      return {
        backgroundColor: 'transparent ',
        padding: '10px 0',
        textAlign: 'center',
        color: '#07acc2',
        border: 'none',
        fontSize: '20px'
      }
    },
    cellStyle() {
      return {
        padding: '7px 0',
        textAlign: 'center',
        backgroundColor: 'transparent ',
        color: '#c7e7ff',
        border: 'none',
        fontSize: '20px'
      }
    }

  }

}
</script>

<style lang="scss" scoped>
$main_color: #09d8f2;
$color01: #00FFFF;
.tableData {
  background: transparent;
}

.el-table::before {
  height: 0;
}

.el-table__empty-text {
  color: $main_color;
}

.tableDataCell {
  ::v-deep .cell {
    padding: 0 2px;
  }
}

::v-deep .el-table__body-wrapper::-webkit-scrollbar {
  /* width: 0;宽度为0暗藏 */
  width: 0;
  background: transparent;
}

::v-deep .el-table th,
::v-deep .el-table tr,
::v-deep .el-table td {
  background-color: transparent;
}

.all_block01 {
  width: 187px;
  height: 180px;
}

.all_block02 {
  width: 100%;
  height: 49px;
  background: rgba(9, 216, 242, 0.1);
}

.all_block03 {
  width: 199px;
  height: 180px;
}

.all_block04 {
  width: 100%;
  height: 49px;
  background: rgba(9, 216, 242, 0.1);
}

.kb_center_block_children {
  height: 180px;
  //border: 1px solid $kbBorderColor;
  width: 240px;
  display: flex;
  z-index: 2;
  justify-content: space-around;
  align-items: center;
  flex-direction: column;
  margin: 10px;
  font-size: 22px;

  .box02 {
    background: url("../../assets/images/box02.png") no-repeat;
    transform: scale(1.5);
    width: 145px;
    height: 84px;

  }
}

.all_block05 {
  position: absolute;
  animation: upDown 3s ease-in-out infinite;
  left: 70px;
}

.all_block06 {
  position: absolute;
  animation: upDown2 3s ease-in-out infinite;
  left: 320px;
}

.all_block07 {
  position: absolute;
  animation: upDown 3s ease-in-out infinite;
  left: 570px;
}

@keyframes upDown {
  0% {
    top: 50px;
  }
  50% {
    top: 100px;
  }
  100% {
    top: 50px;
  }
}

@keyframes upDown2 {
  0% {
    top: 100px;
  }
  50% {
    top: 50px;
  }
  100% {
    top: 100px;
  }
}
</style>
